Index: XIOS/trunk/src/interface/fortran_attr/ifilegroup_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/ifilegroup_attr.F90	(revision 802)
+++ XIOS/trunk/src/interface/fortran_attr/ifilegroup_attr.F90	(revision 891)
@@ -12,5 +12,5 @@
 
   SUBROUTINE xios(set_filegroup_attr)  &
-    ( filegroup_id, append, compression_level, description, enabled, format, group_ref, min_digits  &
+    ( filegroup_id, append, compression_level, cyclic, description, enabled, format, group_ref, min_digits  &
     , mode, name, name_suffix, output_freq, output_level, par_access, record_offset, split_freq  &
     , split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix, type  &
@@ -23,4 +23,6 @@
       LOGICAL (KIND=C_BOOL) :: append_tmp
       INTEGER  , OPTIONAL, INTENT(IN) :: compression_level
+      LOGICAL  , OPTIONAL, INTENT(IN) :: cyclic
+      LOGICAL (KIND=C_BOOL) :: cyclic_tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: description
       LOGICAL  , OPTIONAL, INTENT(IN) :: enabled
@@ -47,16 +49,16 @@
       CALL xios(get_filegroup_handle)(filegroup_id,filegroup_hdl)
       CALL xios(set_filegroup_attr_hdl_)   &
-      ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
-      , mode, name, name_suffix, output_freq, output_level, par_access, record_offset, split_freq  &
-      , split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix, type  &
-       )
+      ( filegroup_hdl, append, compression_level, cyclic, description, enabled, format, group_ref  &
+      , min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
+      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
+      , type )
 
   END SUBROUTINE xios(set_filegroup_attr)
 
   SUBROUTINE xios(set_filegroup_attr_hdl)  &
-    ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
-    , mode, name, name_suffix, output_freq, output_level, par_access, record_offset, split_freq  &
-    , split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix, type  &
-     )
+    ( filegroup_hdl, append, compression_level, cyclic, description, enabled, format, group_ref  &
+    , min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
+    , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
+    , type )
 
     IMPLICIT NONE
@@ -65,4 +67,6 @@
       LOGICAL (KIND=C_BOOL) :: append_tmp
       INTEGER  , OPTIONAL, INTENT(IN) :: compression_level
+      LOGICAL  , OPTIONAL, INTENT(IN) :: cyclic
+      LOGICAL (KIND=C_BOOL) :: cyclic_tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: description
       LOGICAL  , OPTIONAL, INTENT(IN) :: enabled
@@ -88,16 +92,16 @@
 
       CALL xios(set_filegroup_attr_hdl_)  &
-      ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
-      , mode, name, name_suffix, output_freq, output_level, par_access, record_offset, split_freq  &
-      , split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix, type  &
-       )
+      ( filegroup_hdl, append, compression_level, cyclic, description, enabled, format, group_ref  &
+      , min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
+      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
+      , type )
 
   END SUBROUTINE xios(set_filegroup_attr_hdl)
 
   SUBROUTINE xios(set_filegroup_attr_hdl_)   &
-    ( filegroup_hdl, append_, compression_level_, description_, enabled_, format_, group_ref_, min_digits_  &
-    , mode_, name_, name_suffix_, output_freq_, output_level_, par_access_, record_offset_, split_freq_  &
-    , split_freq_format_, sync_freq_, time_counter_, time_counter_name_, timeseries_, ts_prefix_  &
-    , type_ )
+    ( filegroup_hdl, append_, compression_level_, cyclic_, description_, enabled_, format_, group_ref_  &
+    , min_digits_, mode_, name_, name_suffix_, output_freq_, output_level_, par_access_, record_offset_  &
+    , split_freq_, split_freq_format_, sync_freq_, time_counter_, time_counter_name_, timeseries_  &
+    , ts_prefix_, type_ )
 
     IMPLICIT NONE
@@ -106,4 +110,6 @@
       LOGICAL (KIND=C_BOOL) :: append__tmp
       INTEGER  , OPTIONAL, INTENT(IN) :: compression_level_
+      LOGICAL  , OPTIONAL, INTENT(IN) :: cyclic_
+      LOGICAL (KIND=C_BOOL) :: cyclic__tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: description_
       LOGICAL  , OPTIONAL, INTENT(IN) :: enabled_
@@ -137,4 +143,9 @@
       ENDIF
 
+      IF (PRESENT(cyclic_)) THEN
+        cyclic__tmp = cyclic_
+        CALL cxios_set_filegroup_cyclic(filegroup_hdl%daddr, cyclic__tmp)
+      ENDIF
+
       IF (PRESENT(description_)) THEN
         CALL cxios_set_filegroup_description(filegroup_hdl%daddr, description_, len(description_))
@@ -221,5 +232,5 @@
 
   SUBROUTINE xios(get_filegroup_attr)  &
-    ( filegroup_id, append, compression_level, description, enabled, format, group_ref, min_digits  &
+    ( filegroup_id, append, compression_level, cyclic, description, enabled, format, group_ref, min_digits  &
     , mode, name, name_suffix, output_freq, output_level, par_access, record_offset, split_freq  &
     , split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix, type  &
@@ -232,4 +243,6 @@
       LOGICAL (KIND=C_BOOL) :: append_tmp
       INTEGER  , OPTIONAL, INTENT(OUT) :: compression_level
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: cyclic
+      LOGICAL (KIND=C_BOOL) :: cyclic_tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: description
       LOGICAL  , OPTIONAL, INTENT(OUT) :: enabled
@@ -256,16 +269,16 @@
       CALL xios(get_filegroup_handle)(filegroup_id,filegroup_hdl)
       CALL xios(get_filegroup_attr_hdl_)   &
-      ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
-      , mode, name, name_suffix, output_freq, output_level, par_access, record_offset, split_freq  &
-      , split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix, type  &
-       )
+      ( filegroup_hdl, append, compression_level, cyclic, description, enabled, format, group_ref  &
+      , min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
+      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
+      , type )
 
   END SUBROUTINE xios(get_filegroup_attr)
 
   SUBROUTINE xios(get_filegroup_attr_hdl)  &
-    ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
-    , mode, name, name_suffix, output_freq, output_level, par_access, record_offset, split_freq  &
-    , split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix, type  &
-     )
+    ( filegroup_hdl, append, compression_level, cyclic, description, enabled, format, group_ref  &
+    , min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
+    , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
+    , type )
 
     IMPLICIT NONE
@@ -274,4 +287,6 @@
       LOGICAL (KIND=C_BOOL) :: append_tmp
       INTEGER  , OPTIONAL, INTENT(OUT) :: compression_level
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: cyclic
+      LOGICAL (KIND=C_BOOL) :: cyclic_tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: description
       LOGICAL  , OPTIONAL, INTENT(OUT) :: enabled
@@ -297,16 +312,16 @@
 
       CALL xios(get_filegroup_attr_hdl_)  &
-      ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
-      , mode, name, name_suffix, output_freq, output_level, par_access, record_offset, split_freq  &
-      , split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix, type  &
-       )
+      ( filegroup_hdl, append, compression_level, cyclic, description, enabled, format, group_ref  &
+      , min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
+      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
+      , type )
 
   END SUBROUTINE xios(get_filegroup_attr_hdl)
 
   SUBROUTINE xios(get_filegroup_attr_hdl_)   &
-    ( filegroup_hdl, append_, compression_level_, description_, enabled_, format_, group_ref_, min_digits_  &
-    , mode_, name_, name_suffix_, output_freq_, output_level_, par_access_, record_offset_, split_freq_  &
-    , split_freq_format_, sync_freq_, time_counter_, time_counter_name_, timeseries_, ts_prefix_  &
-    , type_ )
+    ( filegroup_hdl, append_, compression_level_, cyclic_, description_, enabled_, format_, group_ref_  &
+    , min_digits_, mode_, name_, name_suffix_, output_freq_, output_level_, par_access_, record_offset_  &
+    , split_freq_, split_freq_format_, sync_freq_, time_counter_, time_counter_name_, timeseries_  &
+    , ts_prefix_, type_ )
 
     IMPLICIT NONE
@@ -315,4 +330,6 @@
       LOGICAL (KIND=C_BOOL) :: append__tmp
       INTEGER  , OPTIONAL, INTENT(OUT) :: compression_level_
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: cyclic_
+      LOGICAL (KIND=C_BOOL) :: cyclic__tmp
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: description_
       LOGICAL  , OPTIONAL, INTENT(OUT) :: enabled_
@@ -346,4 +363,9 @@
       ENDIF
 
+      IF (PRESENT(cyclic_)) THEN
+        CALL cxios_get_filegroup_cyclic(filegroup_hdl%daddr, cyclic__tmp)
+        cyclic_ = cyclic__tmp
+      ENDIF
+
       IF (PRESENT(description_)) THEN
         CALL cxios_get_filegroup_description(filegroup_hdl%daddr, description_, len(description_))
@@ -430,5 +452,5 @@
 
   SUBROUTINE xios(is_defined_filegroup_attr)  &
-    ( filegroup_id, append, compression_level, description, enabled, format, group_ref, min_digits  &
+    ( filegroup_id, append, compression_level, cyclic, description, enabled, format, group_ref, min_digits  &
     , mode, name, name_suffix, output_freq, output_level, par_access, record_offset, split_freq  &
     , split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix, type  &
@@ -442,4 +464,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: compression_level
       LOGICAL(KIND=C_BOOL) :: compression_level_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: cyclic
+      LOGICAL(KIND=C_BOOL) :: cyclic_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: description
       LOGICAL(KIND=C_BOOL) :: description_tmp
@@ -485,16 +509,16 @@
       CALL xios(get_filegroup_handle)(filegroup_id,filegroup_hdl)
       CALL xios(is_defined_filegroup_attr_hdl_)   &
-      ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
-      , mode, name, name_suffix, output_freq, output_level, par_access, record_offset, split_freq  &
-      , split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix, type  &
-       )
+      ( filegroup_hdl, append, compression_level, cyclic, description, enabled, format, group_ref  &
+      , min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
+      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
+      , type )
 
   END SUBROUTINE xios(is_defined_filegroup_attr)
 
   SUBROUTINE xios(is_defined_filegroup_attr_hdl)  &
-    ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
-    , mode, name, name_suffix, output_freq, output_level, par_access, record_offset, split_freq  &
-    , split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix, type  &
-     )
+    ( filegroup_hdl, append, compression_level, cyclic, description, enabled, format, group_ref  &
+    , min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
+    , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
+    , type )
 
     IMPLICIT NONE
@@ -504,4 +528,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: compression_level
       LOGICAL(KIND=C_BOOL) :: compression_level_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: cyclic
+      LOGICAL(KIND=C_BOOL) :: cyclic_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: description
       LOGICAL(KIND=C_BOOL) :: description_tmp
@@ -546,16 +572,16 @@
 
       CALL xios(is_defined_filegroup_attr_hdl_)  &
-      ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
-      , mode, name, name_suffix, output_freq, output_level, par_access, record_offset, split_freq  &
-      , split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix, type  &
-       )
+      ( filegroup_hdl, append, compression_level, cyclic, description, enabled, format, group_ref  &
+      , min_digits, mode, name, name_suffix, output_freq, output_level, par_access, record_offset  &
+      , split_freq, split_freq_format, sync_freq, time_counter, time_counter_name, timeseries, ts_prefix  &
+      , type )
 
   END SUBROUTINE xios(is_defined_filegroup_attr_hdl)
 
   SUBROUTINE xios(is_defined_filegroup_attr_hdl_)   &
-    ( filegroup_hdl, append_, compression_level_, description_, enabled_, format_, group_ref_, min_digits_  &
-    , mode_, name_, name_suffix_, output_freq_, output_level_, par_access_, record_offset_, split_freq_  &
-    , split_freq_format_, sync_freq_, time_counter_, time_counter_name_, timeseries_, ts_prefix_  &
-    , type_ )
+    ( filegroup_hdl, append_, compression_level_, cyclic_, description_, enabled_, format_, group_ref_  &
+    , min_digits_, mode_, name_, name_suffix_, output_freq_, output_level_, par_access_, record_offset_  &
+    , split_freq_, split_freq_format_, sync_freq_, time_counter_, time_counter_name_, timeseries_  &
+    , ts_prefix_, type_ )
 
     IMPLICIT NONE
@@ -565,4 +591,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: compression_level_
       LOGICAL(KIND=C_BOOL) :: compression_level__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: cyclic_
+      LOGICAL(KIND=C_BOOL) :: cyclic__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: description_
       LOGICAL(KIND=C_BOOL) :: description__tmp
@@ -616,4 +644,9 @@
       ENDIF
 
+      IF (PRESENT(cyclic_)) THEN
+        cyclic__tmp = cxios_is_defined_filegroup_cyclic(filegroup_hdl%daddr)
+        cyclic_ = cyclic__tmp
+      ENDIF
+
       IF (PRESENT(description_)) THEN
         description__tmp = cxios_is_defined_filegroup_description(filegroup_hdl%daddr)