Index: XIOS/trunk/src/interface/fortran/ixios_interfaces.F90
===================================================================
--- XIOS/trunk/src/interface/fortran/ixios_interfaces.F90	(revision 932)
+++ XIOS/trunk/src/interface/fortran/ixios_interfaces.F90	(revision 934)
@@ -88,4 +88,9 @@
                                               xios(get_generate_rectilinear_domain_attr_hdl), &
                                               xios(is_defined_generate_rectilinear_domain_attr_hdl)
+USE icompute_connectivity_domain, ONLY : xios(get_compute_connectivity_domain_handle)
+
+USE icompute_connectivity_domain_attr, ONLY : xios(set_compute_connectivity_domain_attr_hdl), &
+                                              xios(get_compute_connectivity_domain_attr_hdl), &
+                                              xios(is_defined_compute_connectivity_domain_attr_hdl)
 
 USE ireduce_axis_to_scalar, ONLY : xios(get_reduce_axis_to_scalar_handle)
@@ -103,5 +108,6 @@
                       xios(add_generatedomaintodomain), xios(add_zoomaxistoaxis),                          &
                       xios(add_interpolateaxistoaxis), xios(add_inverseaxistoaxis), xios(add_scalar),      &
-                      xios(add_scalargroup), xios(add_scalartogrid), xios(add_reduceaxistoscalartoscalar)
+                      xios(add_scalargroup), xios(add_scalartogrid), xios(add_reduceaxistoscalartoscalar), &
+                      xios(add_computeconnectivitydomaintodomain)
 
 PRIVATE
@@ -116,5 +122,6 @@
                    xios(set_interpolate_domain_attr_hdl), xios(set_inverse_axis_attr_hdl),                   &
                    xios(set_generate_rectilinear_domain_attr_hdl), xios(set_scalar_attr_hdl),                &
-                   xios(set_scalargroup_attr_hdl), xios(set_reduce_axis_to_scalar_attr_hdl)
+                   xios(set_scalargroup_attr_hdl), xios(set_reduce_axis_to_scalar_attr_hdl),                 &
+                   xios(set_compute_connectivity_domain_attr_hdl)
 END INTERFACE xios(set_attr)
 
@@ -128,5 +135,6 @@
                    xios(get_interpolate_domain_attr_hdl), xios(get_inverse_axis_attr_hdl),                   &
                    xios(get_generate_rectilinear_domain_attr_hdl), xios(get_scalar_attr_hdl),                &
-                   xios(get_scalargroup_attr_hdl), xios(get_reduce_axis_to_scalar_attr_hdl)
+                   xios(get_scalargroup_attr_hdl), xios(get_reduce_axis_to_scalar_attr_hdl),                 &
+                   xios(get_compute_connectivity_domain_attr_hdl)
 END INTERFACE xios(get_attr)
 
@@ -141,5 +149,5 @@
                    xios(is_defined_inverse_axis_attr_hdl), xios(is_defined_generate_rectilinear_domain_attr_hdl),                 &
                    xios(is_defined_scalar_attr_hdl), xios(is_defined_scalargroup_attr_hdl),                                       &
-                   xios(is_defined_reduce_axis_to_scalar_attr_hdl)
+                   xios(is_defined_reduce_axis_to_scalar_attr_hdl), xios(is_defined_compute_connectivity_domain_attr_hdl)
 END INTERFACE xios(is_defined_attr)
 
@@ -153,5 +161,6 @@
                    xios(get_interpolate_domain_handle), xios(get_inverse_axis_handle),              &
                    xios(get_generate_rectilinear_domain_handle), xios(get_scalar_handle),           &
-                   xios(get_scalargroup_handle), xios(get_reduce_axis_to_scalar_handle)
+                   xios(get_scalargroup_handle), xios(get_reduce_axis_to_scalar_handle),            &
+                   xios(get_compute_connectivity_domain_handle)
 END INTERFACE xios(get_handle)
 
@@ -164,5 +173,6 @@
                    xios(add_interpolatedomaintodomain), xios(add_generatedomaintodomain),                            &
                    xios(add_zoomaxistoaxis), xios(add_interpolateaxistoaxis), xios(add_inverseaxistoaxis),           &
-                   xios(add_scalar), xios(add_scalartogrid), xios(add_reduceaxistoscalartoscalar)
+                   xios(add_scalar), xios(add_scalartogrid), xios(add_reduceaxistoscalartoscalar),                   &
+                   xios(add_computeconnectivitydomaintodomain)
 END INTERFACE xios(add_child)
 